// NoPro - webwork 2007-2016

/**
 * some handy debug-functions for js/jquery
 * consistant usage of ; is mandatory for passing this script through liblock
 * no usage of default params in function-declarations for compatibility with ALL browsers (opera)
 */

// 2014-01-08 changed nopro-dragging for #dbgbox into npjq-dragging 
// 2014-03-15 bugfix npjq-dragging() add scroll X/Y for fixed obj
// 2016-05-05 added aoi2txt(), added defaults for undefined params in dbg() and dump_obj() plus some css-cosmetics on dbgbox
//     "      added listall_js() reload_yodbg() and reload_button()


// some global vars
var yodbg_src = null;
var crlf = "\r\n";

function scrolldown(jso) { jso.scrollTop = jso.scrollHeight; }

function dump_obj(o, here) { // debug-fn
    var info = "";
    $.each(o, function (k, v) { info += 'k=' +k+ ', v=' +v+ "\n"; });
    if(here || here == undefined)
	dbg(info, true);
    else
	alert(info);
}

function dbg(msg, app, cont) {
    var text = cont ? '<div class="'+ cont +'">' : '<pre>';
    if(app || app == undefined) {
	$('.dbginfo').append(text + msg.replace(/</g,'&lt;'));
	scrolldown($('.dbginfo')[0]);	
    } else {
	$('#dbgbox, .dbginfo').height('auto');
	$('.dbginfo').html(text + msg);
    }
}

/***
 * do init() immediately and dont use $.ready()
 */
// view dbgbox
$('body').append('<div id="dbgbox" class="box round9px fix"></div>');
$('#dbgbox')
    .css({'width': "50%", 'min-width': '350px', 'max-height': '80%', 'min-height': '100px', 'background':'white', 'padding': "1.75ch 0 .25ch 6px", 'z-index': lastzi=2})
    .append('<div class="dbginfo ascroll rel"></div>')
    //.append('<textarea class="dbginfo ascroll rel" />')	// has resize-corner 
    .append('<div class="npjq2move2 wintop round movx">debug-info</div>')
    .append('<div class="dbgxtra abs"><div class="clix" title="info">&Theta;</div><div class="dbgxval hidden">X: | Y:</div></div>')
    .delegate('.dbgxtra .clix, .dbgxtra .clix *', 'dblclick', function(e) { $('#dbgbox').css({'top': 0}); return false; }) // emergency drag-back
    .delegate('.dbgxtra .clix, .dbgxtra .clix *', 'click', function(e) {
	if($('#dbgbox .dbgxval').is(':hidden')) {
	    $('#dbgbox .dbgxval').show();
	    $(window).mousemove(function(e) {
		$('#dbgbox .dbgxval').html('X: '+e.clientX+' | Y: '+e.clientY);
	    });
	} else {
	    $('#dbgbox .dbgxval').hide();
	    $(window).off('mousemove');
	}
    })
    .append('<div class="winrsz res_se" title="resize">#</div>')
    .append('<div class="xit round clix" title="clear">O</div>')
    .delegate('.xit, .xit *', 'click', function(e) { dbg('', false); return false; })
;
$('#dbgbox .dbgxtra').css({'right': '12px', 'bottom': 0, 'padding': '1px 2px', 'border': 'thin solid', 'font-size': '14px', 'background': '#E8E8FF'});
$('#dbgbox .dbgxtra .clix').css({'float': 'right', 'background': 'silver'});
$('#dbgbox .dbgxval').css({'min-width': '16ch'});
if(is_mobile()) {
    $('#dbgbox .xit').css({'font-size': '32px'});
    $('#dbgbox')
	.delegate('.xit, .xit *', 'touchstart', function(e) { dbg('', false); return false; })
	.delegate('.wintop, .dbginfo', 'touchstart', function(eve) {
	    follow = document.getElementById('dbgbox');
	    if(!follow) {
		dbg(eve.type+ ' id not found');
		return true;
	    }
	    eve.preventDefault();
	    var touch = eve.originalEvent.touches[0] || eve.originalEvent.changedTouches[0];
	    x0 = touch.clientX;
	    y0 = touch.clientY;
	    // ensure that positioning css-vals are set
	    if(!follow.style.left) { follow.style.left = follow.offsetLeft +"px"; }
	    if(!follow.style.top)  { follow.style.top  = follow.offsetTop  +"px"; }
	    fx1 = parseInt(follow.style.left);
	    fy1 = parseInt(follow.style.top);
	    $(document)
		.bind('touchmove', function(e) { return dragit(e); })
		.bind('touchend touchcancel', function(e) {
		    $(document).off('touchmove touchend touchcancel');
		    follow = null;
		    return false;
		})
	    ;
	    return false;
	});
} else {
    $('#dbgbox')
    //.delegate('.wintop', 'mousedown', function(e) { drag(this.parentNode, e, true); return false; }) // wintop already has class npjq2move2
	.delegate('.winrsz', 'mousedown', function(e) { return jq_resize(e, '#dbgbox, #dbgbox .dbginfo'); })
	.delegate('.winrsz', 'dblclick', function(e) { $('#dbgbox').css({'top': 0}); return false; }) // yet another emergency drag-back
    ;
}
var tmp = $(window).width() - $('#dbgbox').outerWidth(true) -8;
$('#dbgbox').css({'top': '20px', 'left': tmp+'px'});
//tmp = $('#dbgbox').css('max-height');		// works with firefox only
tmp = parseInt($(window).height() * .8) + 'px';
$('.dbginfo').css({'max-height': tmp, 'min-height': '100px'});
$('.movx')
    .mousedown(function() {$('.movx:hover').css({'cursor':'move'})})
    .mouseup(function() {$('.movx:hover').css({'cursor':'crosshair'})})
    .mouseout(function() {$('.movx:hover').css({'cursor':'crosshair'})})
;
dbg("You are running jQuery version: " + JQV, false, 'txt');

function jq_clean(jqs) {
    // 
    $(jqs).clearQueue();
    $(jqs).stop();
    $(jqs).unbind();
    //$(jqs).off();
}

function recuview(o) {
    // recursive view object
    // return string

    if(typeof(o) != 'object') {
	dbg("recuview(): "+ typeof(o) +': '+o, true);
	return;
    }
    
    var dst = crlf+ '<dl>';
    $.each(o, function(k,v) {
	if(typeof(v) == 'object') {
	    dst += crlf+ '<dt>'+ k +': {</dt>';
	    dst += crlf+ '<dd>';
	    dst += recuview(o[k]);
	    dst += crlf+ '</dd><dt>}</dt>';
	} else
	    dst += crlf+ '<dt>'+ k +': '+ v +'</dt>';
    });
    dst += crlf+ '</dl>';
    return dst;
}
function flatten_js(js) {
    // re-format minified js
    return js.replace(/([}{;])/g, '$1'+crlf);
}

function aoi2txt(o, aoi) {
    // return textline with array of interest
    var k,kp,v,inf='';
    for(k in aoi) {
	kp = aoi[k];
	v = o[kp];
	if(v) inf += '['+kp+'='+v+']';
    }
    return inf;
}

function listall_js() { $('script').each(function(k,v) { dbg(k+". "+v.src, 1, 'txt'); }); }

function reload_yodbg(src) {
    // dyamic (re)load JS
    if(src == undefined || src == null) src = yodbg_src;
    $('script').each(function(k,v) { if(v.src == src){ v.remove(); }});
    $('script').append( $('<'+'script>', {type: "text/javascript", src: src}) );
    dbg("relodeded "+src, 1, 'msg');
}

function reload_button(o, css) {
    // append yodbg-reload-button
    if(o == undefined || o == null) o = $('#dbgbox');
    var css1 = { right: 0, top: "2ch", height: "3ch", width: "12ch" };
    var html = '<div id="yoreload_div" class="abs"><input type="button" id="yoreload_but" value="Reload yoDbg" onclick="reload_yodbg()" /></div';
    $('#yoreload_div').remove();
    $(o).append(html);
    $('#yoreload_div', o).css(css1);
    if(css !== undefined) $('#yoreload_div', o).css(css);
    dbg("reload-button added", 1, 'msg');
}
