<?php
/**
 * tools to decode hidden and possible malicious scripts
 */

define ('LF', "\n");
function show($vn) { echo "$vn = ".$GLOBALS[$vn].LF; }

function analyze($v, $d) {
  // recursive decoder
  $l = strlen($v);
  echo "depth $d, len $l:".LF;
  
  $v = trim($v);
  if(strpos($v, 'preg_replace') === 0) {
    // we grab and analyze what would be eval()-ed
    $p1 = strpos($v , '(');
    $args = trim(substr($v, $p1+1));
    $q1 = $args[0];
    $p2 = strpos($args, $q1, 1);
    $arg1 = substr($args, 1, $p2-1); dbg("arg1 : ".$arg1, 0);
    
    $p3 = strpos($args, ',', $p2);
    $q2 = substr(trim($args, $p3+1), 0, 1);
    $p3 = strpos($args, $q2, $p3);
    $p4 = strpos($args, $q2, $p3+1);
    $arg2 = substr($args, $p3+1, $p4-$p3-1); dbg("arg2 : ".$arg2, 0);
    #dbg(str_rot13($arg2), 1);

    $p5 = strpos($args, ',', $p4);
    $q3 = substr(trim($args, $p5+1), 0, 1);
    $p5 = strpos($args, $q3, $p5);
    $p6 = strpos($args, $q3, $p5+1);
    $arg3 = substr($args, $p5+1, $p6-$p5-1); #dbg("arg3 : ".$arg3, 1);

    $neval = substr($arg1, 0, strlen($arg1)-1); dbg("neval : ". $neval, 0);
    $r = preg_replace($neval, $arg2, $arg3);
    dbg($r, 1);
  }
  else if(strpos($v, 'eval') === 0) {
    // we grab and analyze what would be eval()-ed
    
    $p1 = strpos($v, '(');
    $p2 = strpos($v, ';');
    $v2 = substr($v, $p1+1, $p2-$p1-2); #die($v2.LF);
    analyze($v2, $d+1);
    
  } else if(strpos($v, '$') === 0) {
    // a previously defined var holds a function-name

    // we isoloate the var-name
    $p1 = strpos($v, '(');
    $vn = substr($v, 1, $p1-1);

    // we get the 1st function
    $fn1 = $GLOBALS[(string)$vn];
    
    if($fn1 == 'base64_decode') {
      $p2 = $p1;
      $p3 = strpos($v, ')', $p1); 
      $arg = substr($v, $p2+1, $p3-$p2-1);
      analyze($fn1($arg), $d+1);
      
    } else {
      if($fn1 != 'gzinflate') die("depth $d: $vn = $fn1".LF.$v);

      // we isoloate the 2nd function (which is in clear-text)
      $p2 = strpos($v, '(', $p1+1); 
      $fn2 = substr($v, $p1+1, $p2-$p1-1); 
      if($fn2 != 'base64_decode') die("depth $d: $vn = $fn1".LF.$v);

      // we isolate the arg and analyze it
      $p3 = strpos($v, ')', $p2); 
      $arg = substr($v, $p2+1, $p3-$p2-1);
      analyze($fn1($fn2($arg)), $d+1);
    }
    
  } else {
    // output what is left
    
    #echo "depth $d, len $l:".LF;
    echo $v.LF;
  }
}

